#ifndef __CDIO_COMPAT_DEVICE__
#define __CDIO_COMPAT_DEVICE__


#include "cdio/compat/cycle_break.h"
#include "cdio/device.h"


// FFI-compatible wrappers

const unsigned int vendor_len();
const unsigned int model_len();
const unsigned int revision_len();

bitfield_t drive_cap_error();
bitfield_t drive_cap_unknown();

const driver_id_t* get_drivers();
const driver_id_t* get_device_drivers();
const driver_id_t get_os_driver();


// Symbol compatibility definitions

#if LIBCDIO_SINCE_VERSION_1_0
// Keep the old enum values around, for broader compatibility.
#define DRIVER_BSDI (DRIVER_DEVICE+1)
#define DRIVER_OS2 (DRIVER_DEVICE+2)
#endif

CdIo_t* cdio_open_bsdi_safe(const char*);
CdIo_t* cdio_open_am_bsdi_safe(const char*, const char*);
char* cdio_get_default_device_bsdi_safe();
char** cdio_get_devices_bsdi_safe();

CdIo_t* cdio_open_os2_safe(const char*);
CdIo_t* cdio_open_am_os2_safe(const char*, const char*);
char* cdio_get_default_device_os2_safe();
char** cdio_get_devices_os2_safe();


#endif
