#ifndef __CDIO_COMPAT_SECTOR__
#define __CDIO_COMPAT_SECTOR__


#include "cdio/sector.h"

#include "stdint.h"


// FFI-compatible wrappings

lsn_t min_lsn();
lsn_t max_lsn();

lba_t invalid_lba();
lsn_t invalid_lsn();

size_t sizeof_msf();

unsigned int pregap_sectors();
unsigned int postgap_sectors();

unsigned int cd_mins();
unsigned int secs_per_min();
unsigned int frames_per_min();
unsigned int frames_per_sec();
unsigned int chunks_per_frame();

unsigned int min_session();
unsigned int max_session();

unsigned int sync_size();
unsigned int chunk_size();
unsigned int framesize_sub();

unsigned int header_size();
unsigned int subheader_size();
unsigned int edc_size();
unsigned int mode1_pad_size();
unsigned int ecc_size();

unsigned int framesize();
unsigned int framesize_raw();
unsigned int framesize_rawer();
unsigned int framesize_raw0();
unsigned int framesize_raw1();

unsigned int header_size_xa();
unsigned int tail_size_xa();
unsigned int sync_size_xa();
unsigned int data_size_xa();
unsigned int tagged_size_xa();


const uint8_t* sector_sync_header();

cdio_cd_minutes_sectors max_sectors();


#endif
