{-# OPTIONS_HADDOCK not-home #-}

{-|
Description:    Common types used in the high-level interface.

Copyright:      (c) 2019-2021 Sam May
License:        GPL-3.0-or-later
Maintainer:     ag@eitilt.life

Stability:      stable
Portability:    non-portable (requires libcdio)
-}
module Sound.Libcdio.Types
    ( -- * Disc
      Cdio
    , CdioError
    , CdioErrorType
    , Whence
    , Lsn
    , Track
    , TrackNum
    , TrackFormat
    , SessionArg
      -- * CdText
    , CdText
    , CdTextError
    , CdTextErrorType
    , Info
    , Genre
    , Language
      -- * Hardware
    , DriverId
    , DriverReturnCode
    , HardwareInfo
    , DriveCapabilityRead
    , DriveReadCaps
    , DriveCapabilityWrite
    , DriveWriteCaps
    , DriveCapabilityMisc
    , DriveMiscCaps
    , DriveCaps
    , DiscMode
      -- * Data
    , Filesystem
    , FilesystemClass
    , FilesystemClasses
    , IsoAnalysis
      -- * Logging
    , LibcdioLogger
    , LogEntry
    , LogLevel
    ) where


import Sound.Libcdio.Device
import Sound.Libcdio.Logging
import Sound.Libcdio.Read.CdText
import Sound.Libcdio.Read.Data
import Sound.Libcdio.Read.Filesystem
import Sound.Libcdio.Track
import Sound.Libcdio.Types.Cdio
